#define INCL_DOSSEMAPHORES   /* Semaphore values */
#define INCL_DOSDATETIME     /* Timer support    */
#define INCL_DOS
#define INCL_DOSMEMMGR   /* Include DOS Memory Management APIs */
#define INCL_DOSERRORS   /* DOS error values                   */

#include <stdio.h>
#include <os2.h>

#include "Player.H "

void main(int num,char *arg[])
{
 struct FM_MODULE* pointer;int selector,j,size,period;
 FILE *IN;
 HEV     hevEvent1     = 0; 
 HTIMER  htimerEvent1  = 0;
 ULONG   ulPostCount   = 0;

 
 printf("\nThe Greatest FM Tracer, based on RAD fm files.\nWritten by Ruslan Zalata, 1996.\n\n");

 if(num<2) {printf("Use:   FMT.EXE  <filename.RAD>\n\n");return;}

 DosAllocMem((PVOID)&pointer,0xffff, PAG_WRITE );
 DosSetMem(pointer,0xffff, PAG_DEFAULT | PAG_COMMIT );

 printf("Loading file... 		");
 IN=fopen(arg[1],"rb");
 fseek(IN,0,2);
 size=ftell(IN);
 fseek(IN,0,0);
 printf("%d bytes waiting...\n",size);

 for(j=0;j<size;j++){*((char*)pointer+j)=fgetc(IN);}

 /* Compute selector number */
 selector=(int)(((long)pointer)>>16);

 printf("Module initializing... 		FLAT Pointer %08X; Selector: %04X.\n",(long)pointer,selector);
 initplayer(selector);
 if(((pointer->buffer[17]) & 0x40) != 0) period=55;
 else period=20;



 printf("Semaphore initialization... 	APIRET=%d\n",DosCreateEventSem(NULL,&hevEvent1,DC_SEM_SHARED,FALSE));
 printf("Timer initialization %dHz... 	APIRET=%d\n",1000/period,DosStartTimer(period, (HSEM) hevEvent1,&htimerEvent1));
 printf("FM Tracker initialized!\n");



 printf("Playing...\n\nPress your lovely key to make a quit.\n\n");
 while(1)
 {
  DosWaitEventSem(hevEvent1,500L);
  DosResetEventSem(hevEvent1,&ulPostCount);

/* Use the following two lines in debug mode. 
 *
 *  printf("Line: %04d,  OrderPos: %04d\r",pointer->Line,pointer->OrderPos[0]+pointer->OrderPos[0]*256);
 *  flushall();
 */

  playmusic(selector);
  if(_kbhit()) break;
 }

 printf("FM Tracker deinitialized!          \n");
 endplayer();
 DosStopTimer(htimerEvent1);
 printf("Timer deregistered!\n");
 DosCloseEventSem(hevEvent1);
 printf("Semaphore shutdown!\n\n");
 printf("Big thanx for using the greatest FM tracker.\n\nHave a nice OS/2.\n\n");
}
