;
;      Notification:
;     
;      This file has been ompimized to be compiled via Watcom Assemble
;      aspecialy for use in OS/2 executable modules to produce nice FM music
;      It must be noticed that one of the segments _must_ be linked in IOPL
;      mode, otherwise it wouldn't work!
;
;      Ported by Ruslan Zalata, June 1996.
;
;      You can send any quastions and/or suggestions to
;      E-mail:   root@cc.tyumen.su
;      Fidonet:  2:5077/7
;
;      Have a nice OS/2 FM music :-)

;
;          
;          .                  
;          :                  :
;                                    |
;    ͼ                     -Ŀ
;                      :
;  |                           .
;  :                                  
;                                version 1.0a
;
;                        Code by SHAYDE/REALITY Feb 95
;
;                                    - * -
;
; Feel free to use/hack this code about as much as you like.  In the good old
; dayz of Amiga, ALL tracker writers gave away player source-code so that the
; coder could do what he/she wanted with it.  On PC every tracker writer thinks
; their player code should be protected and they either don't release a player
; or they release it in .OBJ format which means if you need to make changes to
; the code to fit in with your demo/intro you're fucked!!!  So message to all
; tracker writers out there:
; FOR THE SAKE OF CODER SANITY, ALWAYS RELEASE PLAYER CODE FOR YOUR TRACKERS!!
; OTHERWISE WOT'S THE POINT OF WRITING A TRACKER?!?!??!?!  And release it in
; source-code form to reduce head-aches!
;
;				     - * -
;
; This source-code doesn't contain any segment directives so it is only
; INCLUDEable in other source-code.  Also it requires a minimum of a 286
; to run.  I avoided using ASSUMEs so that the code that INCLUDEs this code
; doesn't lose it's ASSUMEs, hence variables are accessed via CS:.  You can
; save a few bytes by dropping them (which you'll need to do if you want to
; use this player in protected-mode), although I use DS: to reference the
; tune segment.
;
;				     - * -
;
; INSTRUCTIONS FOR USE:
;
;	To initialise the player, call "InitPlayer".
;	To stop play, call "EndPlayer".
;	To play music, call "PlayMusic" 50 times a second (18.2/sec for a
;	"slow-timer" tune when bit 6 at offset 17 is set).
;
;


		.386
		public	InitPlayer,_InitPlayer,InitPlayer_,EndPlayer,_EndPlayer,EndPlayer_,PlayMusic,_PlayMusic,PlayMusic_,GetValues,GetValues_

R1SEG SEGMENT BYTE PUBLIC USE16 'DATA'

Notes:
;	include	MUSIC.INC ; this was the default .RAD. it is not necessary.

	org	0e000h

; Tracker commands
cmPortamentoUp	=	1		; Portamento up
cmPortamentoDwn	=	2		; Portamento down
cmToneSlide	=	3		; Tone Slide: xx is speed of slide
cmToneVolSlide	=	5		; Tone slide of 00 + Vol. Slide
cmVolSlide	=	10		; Volume Slide: <50=down, >50=up
cmSetVol	=	12		; set volume
cmJumpToLine	=	13		; Jump to line in next track
cmSetSpeed	=	15		; set speed

FreqStart	=	156h		; low end of frequency in each octave
FreqEnd		=	2aeh		; high end of frequency in each octave
FreqRange	=	FreqEnd-FreqStart


hmm0 db 'InstPtrs->'

InstPtrs	dw	31 dup (0)	; offsets of instrument data
hmm db 'Old43->'
Old43	        db  	9 dup (0)     ; record of 43..   register values
OldA0		db	9 dup (0)	; record of A0..A8 register values
OldB0		db	9 dup (0)	; record of B0..B8 register values

hmm2 db 'ToneSlideSpeed->'

ToneSlideSpeed	db	9 dup (1)	; speed of tone slide
ToneSlideFreqL	db	9 dup (?)	; destination frequency of tone slide
ToneSlideFreqH	db	9 dup (?)

hmm3 db 'ToneSlide->'

ToneSlide	db	9 dup (?)	; tone slide flag
PortSlide	db	9 dup (?)	; portamento slide
VolSlide	db	9 dup (?)	; volume slide

ModSeg		dw	4444h	; segment of module (starts at offset 0)
Speed		db	?	; speed (n/50Hz) of tune
SpeedCnt	db	?	; counter used for deriving speed

OrderSize	dw	?	; no. of entries in Order List
OrderList	dw	?	; offset in module of Order List
OrderPos	dw	?	; current playing position in Order List

PatternList	dw	?	; offset of pattern offset table in module
PatternPos	dw	?	; offset to current line in current pattern
Line		db	?	; current line being played (usually +1)


R1SEG   ENDS

;
; This CODE segment MUST be linked as IOPL!
; Use the following .DEF file within your linking process:
;
;-------------------- Cut Here --------------------------------------------
;PROTMODE
;SEGMENTS  R3SEG CLASS 'CODE' IOPL
;EXPORTS
;  initplayer 1
;  playmusic 1
;-------------------- Cut Here --------------------------------------------
;
R3SEG SEGMENT BYTE PUBLIC USE16 'CODE'

;
; This routine initialises the player.
; IN:
;	ES:	- points to .RAD module to play
; OUT:
;	Carry	- set on error (such as invalid module)
;

_InitPlayer:
InitPlayer_:
InitPlayer    proc   far
		push	bp
		mov	bp, sp
		mov	ax, [bp+6]
		pusha

   shl eax,16
   mov edx,eax
   and eax,0FFFFh
   xor edx,eax
   lea eax,[eax+edx*8+70000h]
   shr eax,16

		mov	ds,ax
		mov	es,ax

		call	EndPlayer	; clear Adlib ready for tune

	; initialise certain Adlib registers that aren't changed
		mov	ax,0120h	; allow waveforms
		call	Adlib
		mov	ax,0800h
		call	Adlib
		mov	ah,0bdh		; no drums, etc.
		call	Adlib

	; check to see if it is a RAD file first
		cmp	word ptr es:[0],'AR'
		jnz	InitPlayer_err
		cmp	word ptr es:[2],' D'
		jnz	InitPlayer_err
		cmp	byte ptr es:[16],10h		; correct version?
		jnz	InitPlayer_err

		mov	ds:ModSeg,es		; keep the segment of module

	; read initial speed
		mov	al,es:[17]
		mov	ah,al
		and	al,1fh
		mov	ds:Speed,al

	; see if there's a description to skip
		mov	si,18
		test	ah,80h			; description flag
		jz	InitPlayer_lc			; no description

		xor	al,al
		jmp	InitPlayer_le

	InitPlayer_ld:	inc	si
	InitPlayer_le:	cmp	es:[si],al		; look for null-termination
		jnz	InitPlayer_ld
		inc	si			; move past null

	; create table of instrument pointers
	InitPlayer_lc:	xor	bx,bx

	InitPlayer_la:	mov	bl,es:[si]		; instrument no.
		inc	si
		add	bx,bx
		jz	InitPlayer_lb			; no more instruments

		mov	ds:InstPtrs-2[bx],si	; record pointer to instrument
		add	si,11
		jmp	InitPlayer_la

	; record offset of order list
	InitPlayer_lb:	xor	ax,ax
		mov	al,es:[si]		; no. of orders in order-list
		mov	ds:OrderSize,ax
		inc	si
		mov	ds:OrderList,si
		xor	bx,bx
		mov	bl,es:[si]		; first pattern to play
		add	bx,bx
		add	si,ax			; move to end of list

	; record table of pattern offsets
		mov	ds:PatternList,si
		mov	ax,es:[si+bx]		; first pattern offset
		mov	ds:PatternPos,ax	; pointer to first pattern

	; initial pointers
		xor	ax,ax
		mov	ds:OrderPos,ax		; start at position 0.
		mov	ds:SpeedCnt,al
		mov	ds:Line,al		; start at line 0

		clc
		jmp	InitPlayer_lx			; successful initialisation

	InitPlayer_err:	stc
	InitPlayer_lx:	popa
		pop	bp

		mov	eax,0
		jc	err
re:		ret	2
err:		mov	eax,1
		jmp	re

InitPlayer    endp



;
; This stops music playback (stops sound channels).
;
_EndPlayer:
EndPlayer_:
EndPlayer     proc   far
              push   ax
		mov	ax,020h shl 8
	EndPlayer_la:	call	Adlib
		inc	ah
		cmp	ah,00f6h
		jb	EndPlayer_la
		pop	ax
		ret
EndPlayer     endp




;
; This routine does the actual playing.  It MUST be called 50 times a second
; to maintain accurate music playback.  Refer to accompanying timer source-code
; for ways of providing a 50/sec timer service.
;
_PlayMusic:
PlayMusic_:
PlayMusic     proc   far
		push	bp
		mov	bp, sp
		mov	ax, [bp+6]
		pusha

   shl eax,16
   mov edx,eax
   and eax,0FFFFh
   xor edx,eax
   lea eax,[eax+edx*8+70000h]
   shr eax,16
   mov ds,ax

		push	ds

;		mov	ax,seg R1SEG
;		mov	ds,ax

;		cmp	ax,0
;		jnz	PlayMusic_lndf
;		mov	ax,seg R1SEG
;	PlayMusic_lndf:
;		mov	ds,ax

		cmp	ds: byte ptr SpeedCnt,0
		jz	PlayMusic_la		; play a line of music
		dec	ds: byte ptr SpeedCnt

	; no new line, so just update any effects
		call	UpdateNotes
		jmp	PlayMusic_lx

	; switch off any effects that are in operation
	PlayMusic_la:	mov	si,8
		xor	al,al

	PlayMusic_laa:	mov	ds:PortSlide[si],al	; reset any slides
		mov	ds:VolSlide[si],al	; reset any slides
		mov	ds:ToneSlide[si],al	; reset any slides
		dec	si
		jns	PlayMusic_laa

	; playing a new line, PatternPos should have been set-up already
		mov	si,ds:PatternPos
		or	si,si
		jz	PlayMusic_lb		; rest of this pattern is blank

		mov	al,[si]		; line indicator
		and	al,7fh		; eliminate bit 7
		cmp	al,ds:Line	; is this current line?
		jnz	PlayMusic_lb		; haven't reached it yet

		test	byte ptr [si],80h	; last line?
		jz	PlayMusic_lc		; no, still more to check
		mov	ds: word ptr PatternPos,0	; mark rest of pattern as blank

	PlayMusic_lc:	inc	si		; move to first channel

	; play channels
	PlayMusic_lf:	mov	cl,[si]		; channel we are processing
		push	cx
		and	cl,7fh		; get rid of bit 7
		mov	ax,1[si]	; AL=octave/note, AH=inst/command
		add	si,3

		test	ah,15		; if there's a cmd, there'll be a param.
		jz	PlayMusic_le		; no parameter byte
		mov	ch,[si]		; read parameter
		inc	si

	PlayMusic_le:	call	PlayNote	; play the note

		pop	cx
		jc	PlayMusic_lg		; skip rest of line, AX has new line

		test	cl,80h		; last channel to play?
		jz	PlayMusic_lf		; not yet

		mov	ds:PatternPos,si; keep position in crunched track

	; update pointers
	PlayMusic_lb:	mov	al,ds:Speed	; needs to be set AFTER note playing
		dec	al
;mov	al,1h
		mov	ds:SpeedCnt,al	;    for new speeds to take effect!

		inc	ds: byte ptr Line
		cmp	ds: byte ptr Line,64	; end of pattern?
		jb	PlayMusic_lx		; nope

		mov	ds: byte ptr Line,0	; top of next pattern
              push cs
              call   NextPattern

	PlayMusic_lx:


		pop	ds
		popa
		pop	bp
		ret	2

	; jump to line AX
	PlayMusic_lg:	mov	bl,ds:Speed	; needs to be set AFTER note playing
		mov	ds:SpeedCnt,bl	;    for new speeds to take effect!

		mov	ds:Line,al

		; find start of next pattern
		push cs
		call	NextPattern
		jz	PlayMusic_lx		; there isn't any data in next pattern

		; find line that is greater or equal to the current line
	PlayMusic_ll:	mov	cl,[si]		; line id.
		and	cl,7fh		; ignore bit 7
		cmp	cl,al
		jae	PlayMusic_lh		; found line

		test	byte ptr [si],80h
		jz	PlayMusic_li		; not last line
		xor	si,si
		jmp	PlayMusic_lh		; ignore rest of pattern as it's last

		; skip to next line definition
	PlayMusic_li:	inc	si
	PlayMusic_lj:	mov	cl,[si]
		add	si,3
		test	byte ptr ds:[si-1],15	; is there a valid command?
		jz	PlayMusic_lk
		inc	si		; skip parameter

	PlayMusic_lk:	add	cl,cl
		jnc	PlayMusic_lj		; wasn't last channel spec.
		jmp	PlayMusic_ll		; check next line

	PlayMusic_lh:	mov	ds:PatternPos,si
		jmp	PlayMusic_lx





;
; Advances pointers to next pattern in order list.
;
NextPattern:	
		mov	bx,ds:OrderPos
		inc	bx
		cmp	bx,ds:OrderSize
		jb	NextPattern_ld
		xor	bx,bx		; end of tune, move back to start

	NextPattern_ld:	mov	ds:OrderPos,bx
		mov	si,ds:OrderList
		mov	bl,[si+bx]	; no. of next pattern

		test	bl,80h
		jz	NextPattern_lda
		and	bl,7fh
		jmp	NextPattern_ld		; bit 7 = jump to new order

	NextPattern_lda:	mov	si,ds:PatternList
		add	bx,bx
		mov	si,[si+bx]	; offset of next pattern
		mov	ds:PatternPos,si
		or	si,si
		ret

PlayMusic     endp




;
; Plays a note on a channel.
; IN:
;	AL	- Octave (high nibble), Note (low nibble)
;	AH	- instrument (high nibble), command (low nibble)
;	CL	- channel to play note on (0..8)
;	CH	- parameter byte if command is non-zero
; OUT:
;	CARRY	- set if a line is to be jumped to
;	AX	- line to jump to if CARRY set
; Note: don't use SI or segment regs., otherwise registers do not need saving.
;
PlayNote:	mov	di,cx
		and	di,15
		mov	dh,ah
		and	dh,15		; command

		or	al,al
		jz	PlayNote_lb		; no note playing, process command

	; check to see if we are actually performing a tone slide
		cmp	dh,cmToneSlide
		jnz	PlayNote_lt		; nope, play note

		; note/octave are used as parameters then (instrument ignored)
		mov	bx,ax
		and	bx,15		; note
		shr	al,4
		and	ax,7		; octave
		dec	bx		; we want 1..12
		cmp	bx,12
		jae	PlayNote_lx		; not a valid note (probably KEY-OFF)

		imul	ax,FreqRange	; scale octave
		add	bx,bx
		add	ax,cs:NoteFreq[bx]	; add frequency of this note
		sub	ax,FreqStart	; so range starts from zero
		mov	ds:ToneSlideFreqL[di],al	; destination frequency
		mov	ds:ToneSlideFreqH[di],ah

		; set tone slide speed
		mov	byte ptr ds:ToneSlide[di],1	; switch tone slide on
		or	ch,ch
		jz	PlayNote_lx		; use last speed setting
		mov	ds:ToneSlideSpeed[di],ch
		jmp	PlayNote_lx

	; KEY-OFF the previous note
	PlayNote_lt:	push	ax
		mov	al,ds:OldB0[di]	; old register value
		and	al, not 20h	; clear KEY-ON bit
		mov	ds:OldB0[di],al	; so slides after KEYOFF work correctly
		mov	ah,cl
		add	ah,0b0h
		call	Adlib
		pop	ax

	; load instrument (if any)
		mov	dl,ah
		add	al,al
		rcr	dl,1
		shr	dl,3		; instrument no.
		jz	PlayNote_la		; no instrument to load
		call	LoadInst

	; load note into channel
       PlayNote_la:  mov    bl,al
		and	bx,15*2		; note * 2
		cmp	bx,15*2
		jz	PlayNote_lb		; just a KEY-OFF so we're done

		mov	bx,cs:NoteFreq-2[bx]	; frequency of note (BX-1)
		shr	al,3		; octave
		and	al,7*4
		or	al,20h		; KEY-ON
		or	al,bh		; Frequency high byte
		mov	ah,0b0h
		add	ah,cl
		mov	ds:OldB0[di],al	; record the register value
		push	ax

		sub	ah,10h
		mov	al,bl		; Frequency low byte
		mov	ds:OldA0[di],al
		call	Adlib

		pop	ax
		call	Adlib

	; process command (if any), DH has command, CH has parameter
	PlayNote_lb:	xor	bx,bx
		mov	bl,dh		; command
		add	bx,bx
		jmp	cs:Effects[bx]

	PlayNote_lx:	clc
	PlayNote_lxx:	ret
;
; Portamento up
PlayNote_PortUp:	mov	ds:PortSlide[di],ch
		jmp	PlayNote_lx
;
; Portamento down
PlayNote_PortDown:	neg	ch
		mov	ds:PortSlide[di],ch
		jmp	PlayNote_lx
;
; Tone slide to note (no note supplied)
PlayNote_ToneSlide:	or	ch,ch		; parameter has speed of tone slide
		jz	PlayNote_lja		; keep last tone slide speed
		mov	ds:ToneSlideSpeed[di],ch

	PlayNote_lja:	mov	byte ptr ds:ToneSlide[di],1	; tone slide on
		jmp	PlayNote_lx
;
; Volume slide & Volume + Tone Slide
PlayNote_ToneVolSlide:
PlayNote_VolSlide:	cmp	ch,50		; <50 = slide down, >50 = slide up
		jb	PlayNote_lga
		sub	ch,50
		neg	ch

	PlayNote_lga:	mov	ds:VolSlide[di],ch

		cmp	dh,cmToneVolSlide	; just plain volume slide
		jnz	PlayNote_lx
		mov	byte ptr ds:ToneSlide[di],1	; tone slide on
		jmp	PlayNote_lx
;
; Set volume
PlayNote_SetVolume:	call	SetVolume	; CH has volume, CL has channel
		jmp	PlayNote_lx
;
; jump to line in next pattern
PlayNote_JumpToLine:	cmp	ch,64
		jae	PlayNote_lx		; ignore as it is invalid
		xor	ax,ax
		mov	al,ch
		stc
		ret			; skip rest of channels
;
; Set speed
PlayNote_SetSpeed:	mov	ds:Speed,ch
		jmp	PlayNote_lx
;





;
; Check each channel for ongoing effects to update.
;
UpdateNotes:	xor	bh,bh		; channel index
		xor	si,si

	; process portamentos
	UpdateNotes_la:	mov	bl,ds:PortSlide[si]
		or	bl,bl
		jz	UpdateNotes_lb		; no slide for this channel
		call	GetFreq
		mov	ch,bl
		sar	cx,8		; sign extend 8bit->16bit
		add	ax,cx
		call	SetFreq

	; process volume slides
	UpdateNotes_lb:	mov	ch,ds:VolSlide[si]
		mov	cl,ds:Old43[si]	; contains current volume
		and	cl,3fh
		xor	cl,3fh
		or	ch,ch
		jz	UpdateNotes_lc
		jns	UpdateNotes_lba

		; slide volume up
		sub	cl,ch
		cmp	cl,64
		jb	UpdateNotes_lbb
		mov	cl,63
		jmp	UpdateNotes_lbb

		; slide volume down
	UpdateNotes_lba:	sub	cl,ch
		jns	UpdateNotes_lbb
		xor	cl,cl

	UpdateNotes_lbb:	mov	ch,cl
		mov	cl,bh		; channel to set
		call	SetVolume

	; process tone slides
	UpdateNotes_lc:	cmp	ds: byte ptr ToneSlide[si],0
		jz	UpdateNotes_lx		; no tone slide
		mov	bl,ds: byte ptr ToneSlideSpeed[si]	; shouldn't get wiped uc

		; get current absolute frequency
		call	GetFreq

		; sign extend speed/direction
		mov	dh,bl
		sar	dx,8

		; get destination frequency
		mov	cl,ds: byte ptr ToneSlideFreqL[si]
		mov	ch,ds: byte ptr ToneSlideFreqH[si]
		cmp	ax,cx
		jz	UpdateNotes_le		; already at destination?!
		ja	UpdateNotes_ld		; tone slide down (source > dest)

		; doing a tone slide up
		add	ax,dx
		cmp	ax,cx
		jb	UpdateNotes_lg		; still under destination
		jmp	UpdateNotes_le		; reached destination

		; doing a tone slide down
	UpdateNotes_ld:	sub	ax,dx
		cmp	ax,cx
		ja	UpdateNotes_lg		; still over destination

		; reached destination so stop tone slide
	UpdateNotes_le:	mov	ax,cx		; clip it onto destination
		mov	ds: byte ptr ToneSlide[si],0	; disables tone slide

		; write new frequency back to channel
	UpdateNotes_lg:	call	SetFreq

	UpdateNotes_lx:	inc	bh
		inc	si
		cmp	si,9
		jb	UpdateNotes_la
		ret





;
; Returns the current absolute frequency of channel
; IN:
;	SI	- channel
; OUT:
;	AX	- frequency
; USES:
;	CX, DX
;
GetFreq:	mov	cl,ds:OldA0[si]
		mov	ch,ds:OldB0[si]
		and	ch,3		; mask to get high frequency
		sub	cx,FreqStart
		mov	al,ds:OldB0[si]
		shr	al,2
		and	ax,7		; mask to get octave
		mov	dx,FreqRange
		mul	dx
		add	ax,cx
		ret





;
; Sets the channel's frequency
; IN:
;	AX	- absolute frequency
;	SI	- channel
; USES:
;	CX, DX
;
SetFreq:	mov	cx,FreqRange
		xor	dx,dx
		div	cx		; extracts octave in AX and freq. in DX
		add	dx,FreqStart

		mov	ah,ds:OldB0[si]
		and	ah,11100000b	; keep old toggles
		shl	al,2		; move octave to correct bit position
		or	al,ah		; insert octave
		or	al,dh		; insert high frequency
		mov	ah,bh
		add	ah,0b0h
		mov	ds:OldB0[si],al
		call	Adlib

		sub	ah,10h
		mov	al,dl		; low frequency
		mov	ds:OldA0[si],al
		jmp	Adlib





;
; Load in instrument data into a given channel.
; IN:
;	CL	- channel to load instrument into (0..8)
;	DL	- instrument no. (1..31)
;
LoadInst:	push	ax
		push	bx
		push	si

		mov	si,cx
		and	si,0ffh
		mov	ah,cs:ChannelOffs[si]	; Adlib register offsets

		xor	bx,bx
		mov	bl,dl
		dec	bx
		add	bx,bx
		mov	bx,ds:InstPtrs[bx]	; get instrument offset
		or	bx,bx
		jz	LoadInst_lx		; no instrument data ?!

		mov	al,2[bx]
		mov	ds:Old43[si],al	; old 43.. value

		mov	dl,4

	LoadInst_la:	mov	al,1[bx]
		call	Adlib		; load carrier
		add	ah,3
		mov	al,[bx]
		call	Adlib		; load modulator
		add	bx,2

		add	ah,20h-3
		dec	dl
		jnz	LoadInst_la

		add	ah,40h		; do E0 range now
		mov	al,2[bx]
		call	Adlib
		add	ah,3
		mov	al,1[bx]
		call	Adlib

		mov	ah,0c0h
		add	ah,cl
		mov	al,[bx]
		call	Adlib

LoadInst_lx:	pop	si
		pop	bx
		pop	ax
		ret


;
; Outputs a value to an ADLIB register.
; IN:
;	CL	- channel to set volume on
;	CH	- new volume
;
SetVolume:	push	ax
		push	bx

		xor	bx,bx
		mov	bl,cl

	; ensure volume is within range
		cmp	ch,64
		jb	SetVolume_la
		mov	ch,63

	; get old 43.. value
	SetVolume_la:	mov	al,ds:Old43[bx]
		and	al,0c0h		; mask out volume bits
		xor	ch,3fh
		or	al,ch		; insert volume
		mov	ds:Old43[bx],al	; keep new 43.. value

	; write new volume into Adlib
		mov	ah,cs:ChannelOffs[bx]
		add	ah,23h
		call	Adlib

		pop	bx
		pop	ax
		ret







GetValues_:
GetValues     proc   far
;              push   es
;              push   0
;              pop    es
              mov    al,ds:[Old43]
              add    al,ds:[Old43+1]
              add    al,ds:[Old43+2]
              add    al,ds:[Old43+3]
              add    al,ds:[Old43+4]
              add    al,ds:[Old43+5]
              add    al,ds:[Old43+6]
              add    al,ds:[Old43+7]
              add    al,ds:[Old43+8]
;              mov    es:[4f0h],al
              mov    al,ds:[OldA0]
              add    al,ds:[OldA0+1]
              add    al,ds:[OldA0+2]
              add    al,ds:[OldA0+3]
              add    al,ds:[OldA0+4]
              add    al,ds:[OldA0+5]
              add    al,ds:[OldA0+6]
              add    al,ds:[OldA0+7]
              add    al,ds:[OldA0+8]
;              mov    es:[4f1h],al
              mov    al,ds:[OldB0]
              add    al,ds:[OldB0+1]
              add    al,ds:[OldB0+2]
              add    al,ds:[OldB0+3]
              add    al,ds:[OldB0+4]
              add    al,ds:[OldB0+5]
              add    al,ds:[OldB0+6]
              add    al,ds:[OldB0+7]
              add    al,ds:[OldB0+8]
;              mov    es:[4f2h],al
;              pop    es
              ret
GetValues     endp


;
; Outputs a value to an ADLIB register.
; IN:
;	AH	- register no.
;	AL	- value
;
Adlib:		push	ax
		push	dx

		or	edx,edx
		mov	dx,cs:AdlibPort
		xchg	ah,al
		out	dx,al
	
		in	al,dx
		in	al,dx
		in	al,dx
		in	al,dx
		in	al,dx
		in	al,dx
		in	al,dx

		inc	dx
		mov	al,ah
		out	dx,al
		dec	dx
		mov	ah,22
Adlib_la:	
		in	al,dx
		dec	ah
		jnz	Adlib_la


		pop	dx
		pop	ax
		ret






ChannelOffs	db	20h,21h,22h,28h,29h,2ah,30h,31h,32h

		db      'Shit->'

Effects		dw	PlayNote_lx
		dw	PlayNote_PortUp
		dw	PlayNote_PortDown
		dw	PlayNote_ToneSlide
		dw	PlayNote_lx
		dw	PlayNote_ToneVolSlide
		dw	PlayNote_lx
		dw	PlayNote_lx
		dw	PlayNote_lx
		dw	PlayNote_lx
		dw	PlayNote_VolSlide
		dw	PlayNote_lx
		dw	PlayNote_SetVolume
		dw	PlayNote_JumpToLine
		dw	PlayNote_lx
		dw	PlayNote_SetSpeed

NoteFreq	dw	16bh,181h,198h,1b0h,1cah,1e5h	; 156h = C
		dw	202h,220h,241h,263h,287h,2aeh


AdlibPort	dw	388h		; default Adlib base port

R3SEG   ENDS
              end

